﻿Procedure SizeWindowHandler()
  ResizeGadget(0, #PB_Ignore, #PB_Ignore, WindowWidth(0), WindowHeight(0))
EndProcedure

Procedure BuildPDF(PDFFolder.s)
  lpValueName.s = GetFilePart(ProgramFilename()) : lpData = 11001

  If RegCreateKeyEx_(#HKEY_CURRENT_USER, "SOFTWARE\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION", 0, #Null, #REG_OPTION_VOLATILE, #KEY_ALL_ACCESS, #Null, @phkResult, @lpdwDisposition) = #ERROR_SUCCESS
    RegSetValueEx_(phkResult, lpValueName, 0, #REG_DWORD, @lpData, SizeOf(LONG))
    RegCloseKey_(phkResult)

    If OpenWindow(0, 0, 0, 800, 700, "HTML5 PDFJS: PDF Viewer", #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_SizeGadget | #PB_Window_ScreenCentered | #PB_Window_Invisible)
      WebGadget(0, 0, 0, 800, 700, #Null$)
      SetGadgetAttribute(0, #PB_Web_BlockPopupMenu, #True)
      SetGadgetAttribute(0, #PB_Web_BlockPopups, #True)
      WebBrowser2.IWebBrowser2 = GetWindowLongPtr_(GadgetID(0), #GWL_USERDATA)
      WebBrowser2\put_Silent(#True)
      PDFJS.s = PeekS(?pdfFile_Start, ?pdfFile_End - ?pdfFile_Start, #PB_Ascii)
      PDFJS = ReplaceString(PDFJS, "viewer.css", PDFFolder + "Includes/PDFJS/viewer.css")
      PDFJS = ReplaceString(PDFJS, "l10n.js", PDFFolder + "Includes/PDFJS/l10n.js")
      PDFJS = ReplaceString(PDFJS, "pdf.js", PDFFolder + "Includes/PDFJS/pdf.js")
      PDFJS = ReplaceString(PDFJS, "pdf.worker.js", PDFFolder + "Includes/PDFJS/pdf.worker.js")
      PDFJS = ReplaceString(PDFJS, "viewer.js", PDFFolder + "Includes/PDFJS/viewer.js")
      SetGadgetItemText(0, #PB_Web_HtmlCode, PDFJS)
      BindEvent(#PB_Event_SizeWindow, @SizeWindowHandler())
      Repeat : nWait + 1 : WindowEvent() : Delay(1) : Until nWait = 300
      SmartWindowRefresh(0, #True) : StickyWindow(0, 1) : HideWindow(0, 0)
      Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
    EndIf

    If RegOpenKeyEx_(#HKEY_CURRENT_USER, "SOFTWARE\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION", 0, #KEY_SET_VALUE, @phkResult) = #ERROR_SUCCESS
      RegDeleteValue_(phkResult, lpValueName)
      RegCloseKey_(phkResult)
    EndIf
  Else
    MessageRequester("HTML5 PDFJS: PDF Viewer", "Registry update failed." + #LF$ + #LF$ + "Operation cancelled.", #MB_ICONERROR)
  EndIf
EndProcedure

PDFFolder.s = ReplaceString(GetCurrentDirectory(), "\", "/")
BuildPDF(PDFFolder)

DataSection
  pdfFile_Start:
    IncludeBinary "Includes/PDFJS/viewer.html"
  pdfFile_End:
EndDataSection
; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 3
; Folding = -
; EnableXP
; UseIcon = Binaries\pdf.ico
; DisableDebugger
; EnableUnicode