﻿Procedure BuildPlayer(VideoFile.s, VideoFolder.s, VideoZoom.d = 1)
  lpValueName.s = GetFilePart(ProgramFilename()) : lpData = 11001

  If RegCreateKeyEx_(#HKEY_CURRENT_USER, "SOFTWARE\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION", 0, #Null, #REG_OPTION_VOLATILE, #KEY_ALL_ACCESS, #Null, @phkResult, @lpdwDisposition) = #ERROR_SUCCESS
    RegSetValueEx_(phkResult, lpValueName, 0, #REG_DWORD, @lpData, SizeOf(LONG))
    RegCloseKey_(phkResult)

    If OpenWindow(0, 0, 0, 500, 500, "HTML5 VideoJS: Player", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
      WebGadget(0, 0, 0, 500, 500, #Null$) : WebGadget(1, 0, 0, 0, 0, #Null$) : HideGadget(1, 1)
      SetGadgetAttribute(0, #PB_Web_BlockPopupMenu, #True)
      SetGadgetAttribute(0, #PB_Web_BlockPopups, #True)
      SetGadgetAttribute(1, #PB_Web_BlockPopups, #True)
      WebBrowser2_1.IWebBrowser2 = GetWindowLongPtr_(GadgetID(0), #GWL_USERDATA)
      WebBrowser2_1\put_Silent(#True)
      WebBrowser2_2.IWebBrowser2 = GetWindowLongPtr_(GadgetID(1), #GWL_USERDATA)
      WebBrowser2_2\put_Silent(#True)
      IncludeFile "Includes\videojs_player.pbi"
      SetGadgetItemText(1, #PB_Web_HtmlCode, VideoPlayer)

      Repeat
        PageTitle.s = GetGadgetItemText(1, #PB_Web_PageTitle)

        If FindString(GetGadgetItemText(1, #PB_Web_HtmlCode), VideoFile) And PageTitle <> "" : Break : EndIf : WindowEvent() : Delay(1)

      ForEver

      If PageTitle = "error"
        If FileSize(VideoFolder + "TestFiles/moon.mp4") > 0
          BuildPlayer(VideoFolder + "TestFiles/moon.mp4", VideoFolder, 0.7)
        Else
          MessageRequester("HTML5 Video Player with jQuery", "It seems that this video file cannot be found or is not supported." + #LF$ + #LF$ + VideoFile, #MB_ICONSTOP)
        EndIf
      Else
        nPosition = FindString(PageTitle, "x")

        If nPosition
          ExamineDesktops()
          DesktopWidth = DesktopWidth(0)
          DesktopHeight = DesktopHeight(0)
          VideoWidth = Val(Left(PageTitle, nPosition)) + 16
          VideoHeight = Val(Mid(PageTitle, nPosition + 1)) + 16
          ResizeWindow(0, DesktopWidth / 2 - VideoWidth / 2 - 4, DesktopHeight / 2 - VideoHeight / 2 - 16, VideoWidth, VideoHeight)
          ResizeGadget(0, 0, 0, VideoWidth, VideoHeight)
          HTMLCode.s = GetGadgetItemText(1, #PB_Web_HtmlCode)
          HTMLCode = ReplaceString(HTMLCode, "poster", "width='" + Str(VideoWidth - 16) + "' height='" + Str(VideoHeight - 16) + "' poster")
          SetGadgetItemText(0, #PB_Web_HtmlCode, HTMLCode)

          Repeat
            PageTitle = GetGadgetItemText(0, #PB_Web_PageTitle)

            If FindString(GetGadgetItemText(0, #PB_Web_HtmlCode), VideoFile) And PageTitle <> "" : Break : EndIf : WindowEvent() : Delay(1)

          ForEver
        EndIf
        StickyWindow(0, 1) : HideWindow(0, 0)
        Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
      EndIf
    EndIf

    If RegOpenKeyEx_(#HKEY_CURRENT_USER, "SOFTWARE\Microsoft\Internet Explorer\Main\FeatureControl\FEATURE_BROWSER_EMULATION", 0, #KEY_SET_VALUE, @phkResult) = #ERROR_SUCCESS
      RegDeleteValue_(phkResult, lpValueName)
      RegCloseKey_(phkResult)
    EndIf : End
  Else
    MessageRequester("HTML5 VideoJS: Player", "Registry update failed." + #LF$ + #LF$ + "Operation cancelled.", #MB_ICONERROR)
  EndIf
EndProcedure

VideoFile.s = "http://vjs.zencdn.net/v/oceans.mp4"
VideoFolder.s = ReplaceString(GetCurrentDirectory(), "\", "/")
BuildPlayer(VideoFile, VideoFolder, 1.5)
; IDE Options = PureBasic 5.50 (Windows - x64)
; CursorPosition = 2
; Folding = -
; EnableXP
; UseIcon = Binaries\video.ico
; DisableDebugger
; EnableUnicode